using System;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Text;

namespace CsFileCopy
{
	/// <summary>
    /// CsFileCopỹOo̓NXłB
	/// </summary>
	public class Log : ILog
	{
		/// <summary>
		/// G[Ot@C
		/// </summary>
		private const string ERROR_LOG_FILE_NAME = "csfcopy_error.log";

		/// <summary>
		/// ̃NX̃CX^X
		/// </summary>
		private static Log log = new Log();

		/// <summary>
		/// Oo̓NX쐬܂B
		/// </summary>
		private Log()
		{
		}

		/// <summary>
		/// Oo̓NX̃CX^XԂ܂B
		/// </summary>
		/// <returns>Oo̓NX̃CX^X</returns>
		public static Log GetInstance()
		{
			return log;
		}

        /// <summary>
        /// 񃍃Oo͂܂B
        /// </summary>
        /// <param name="s">񃁃bZ[W</param>
        public void Info(string s)
        {
        }

        /// <summary>
        /// xOo͂܂B
        /// </summary>
        /// <param name="s">xbZ[W</param>
        public void Warn(string s)
        {
        }

        /// <summary>
		/// G[Oo͂܂B
		/// </summary>
		/// <param name="s">G[bZ[W</param>
		public void Error(string s)
		{
			StreamWriter writer = null;

			try
			{
				writer = new StreamWriter(
					Application.StartupPath + "\\" + ERROR_LOG_FILE_NAME,
                    true, // Append
                    Encoding.GetEncoding(Constants.SHIFT_JIS));

				DateTime now = DateTime.Now;

				writer.WriteLine("[" + now + "] " + s);
			}
			catch (Exception e)
			{
				Debug.WriteLine(e.Message);
				Debug.WriteLine(e.StackTrace);
			}
			finally
			{
				if (writer != null)
				{
					writer.Close();
				}
			}
		}
	}
}
